program map2trl;
uses dos,crt,fexlib;

 {*****************************************}

type
  tvertice = record
      x,y,z:word;
      unknow,light:byte;
  end;

  tquad = record
        p1,p2,p3,p4,texture:word;
  end;

  ttriangle = record
              p1,p2,p3,texture:word;
  end;


  Ttabla_vertices = record
     num_vertices:word;
         vertice: array[0..8000] of tvertice;
  end;


  Ttabla_quads = record
            num_quads:word;
            quad:array[0..6400] of tquad;

 end;


  Ttabla_triangles = record
            num_triangles:word;
            triangle:array[0..8000] of ttriangle;
 end;

 tface = record
         x1,y1,z1, x2,y2,z2,
         x3,y3,z3, x4,y4,z4:word;
         texture:byte;
 end;



 tarray_of_faces = array [1..2500] of tface;

 tarray_of_vertex = array [1..2000] of tvertice;

 {*****************************************}


var
f:file;
v:^ttabla_vertices;
p:^ttabla_quads;
t:^ttabla_triangles;
faces:^tarray_of_faces;
qv:^tarray_of_vertex;
cara:word;

ox,oy,oz:longint;

scale_x,scale_y,scale_z:longint;



linea:string;
x:longint;
f2:text;
offset:longint;
version:byte;

xini,yini,zini,
xfin,yfin,zfin:longint;


cuenta:word;
resto:word;
altura,anchura,grosura:word;


f3:file;

buf:pointer;
px1,py1,pz1:longint;
px2,py2,pz2:longint;
px3,py3,pz3:longint;
px4,py4,pz4:longint;


fila,columna:integer;

{*****************************************************}
function seek_vertice(var v:ttabla_vertices; x,y,z:real):word;
var
n,i:word;

begin
  i:=0;
  n:=1;
  while (n<=v.num_vertices) and (i=0) do
  begin
       if (v.vertice[n].x=x) and (v.vertice[n].y=y) and (v.vertice[n].z=z) then i:=n;
       n:=n+1;
  end;{end while}

  seek_vertice:=i;

end;


{*****************************************************}
procedure add_vertice(var v:ttabla_vertices; x,y,z:real);
begin

if (seek_vertice(v,x,y,z)=0) and (v.num_vertices<2000) then
  begin
     v.num_vertices:=v.num_vertices+1;

     v.vertice[v.num_vertices].x:=trunc(x);
     v.vertice[v.num_vertices].y:=trunc(y);
     v.vertice[v.num_vertices].z:=trunc(z);
  end;
end;

{********************************************************}


PROCEDURE DEFINE_FACE( var f:tface; x1,y1,z1, x2,y2,z2, x3,y3,z3, x4,y4,z4:integer);
var
ox,oy,oz:integer;

BEGIN

    F.x1:=x1+ox;
    F.y1:=y1+oy;
    F.z1:=z1+oz;

    F.x2:=x2+ox;
    F.y2:=y2+oy;
    F.z2:=z2+oz;

    F.x3:=x3+ox;
    F.y3:=y3+oy;
    F.z3:=z3+oz;

    F.x4:=x4+ox;
    F.y4:=y4+oy;
    F.z4:=z4+oz;

end;


{INICIO PROGRAMA}
BEGIN
new(v);
new(p);
new(t);
new(faces);
new(qv);


fillchar(v^,sizeof(v^),0);
fillchar(p^,sizeof(p^),0);
fillchar(t^,sizeof(t^),0);
fillchar(qv^,sizeof(qv^),0);


v^.num_vertices:=0;
p^.num_quads:=0;
t^.num_triangles:=0;

fila:=wherey;
columna:=wherex;

if fila=25 then begin writeln;fila:=24;end;


assign(f2,'fex.map');
reset(f2);



WHILE NOT EOF(F2) do
BEGIN
linea:='';
readln(f2,linea); {leer linea}
linea:=ltrim(linea);

if left(linea,1)='(' then
   begin

       locate(fila,columna);
       writeln('Faces Found:',p^.num_quads+1);

           {primer cordenada}
           delete(linea,1,at('(',linea));linea:=ltrim(linea);
           px1:= trunc(valstr(left(linea, at(' ',linea))));
           delete(linea,1,at(' ',linea));linea:=ltrim(linea);
           py1:= trunc(valstr(left(linea, at(' ',linea))));
           delete(linea,1,at(' ',linea));linea:=ltrim(linea);
           pz1:= trunc(valstr(left(linea, at(' ',linea))));

           {segunda cordenada}
           delete(linea,1,at('(',linea));linea:=ltrim(linea);
           px2:= trunc(valstr(left(linea, at(' ',linea))));
           delete(linea,1,at(' ',linea));linea:=ltrim(linea);
           py2:= trunc(valstr(left(linea, at(' ',linea))));
           delete(linea,1,at(' ',linea));linea:=ltrim(linea);
           pz2:= trunc(valstr(left(linea, at(' ',linea))));

           {tercer cordenada}
           delete(linea,1,at('(',linea));linea:=ltrim(linea);
           px3:= trunc(valstr(left(linea, at(' ',linea))));
           delete(linea,1,at(' ',linea));linea:=ltrim(linea);
           py3:= trunc(valstr(left(linea, at(' ',linea))));
           delete(linea,1,at(' ',linea));linea:=ltrim(linea);
           pz3:= trunc(valstr(left(linea, at(' ',linea))));
           p^.num_quads:=p^.num_quads+1;

           qv^[p^.num_quads].x:=px1;
           qv^[p^.num_quads].y:=py1;
           qv^[p^.num_quads].z:=pz1;


{**********************************************************}


end;{end if linea='(' }

END; {FIN LEER TODO EL ARCHIVO}

close(f2);

cara:=1;

ox:=0;
oy:=0;
oz:=0;

{felix}
{***Ofset para level 1 *********}
{ox:=0-1800;
oz:=700;
oy:=1800;}

ox:=1800;
oz:=600;
oy:=0-2700;{2700;}

{***************}
scale_x:=1;
scale_y:=1;
scale_z:=1;
{***************}

{ crear las caras}
for x:=1 to (p^.num_quads div 6) do
begin

     zfin:=qv^[cara].z+(scale_z*100);
     xfin:=qv^[cara+1].x+(scale_x*100);

     yini:=qv^[cara+2].y;
     xini:=qv^[cara+3].x;

     yfin:=qv^[cara+4].y+(scale_y*100);

     zini:=qv^[cara+5].z;


     {************************}
{    altura:=abs(yfin-yini);
     yini:=yini-altura;
     yfin:=yfin-altura;

     anchura:=abs(xfin-xini);
     xini:=xini-anchura;
     xfin:=xfin-anchura;

     {************************}

{     if x>1 then begin ox:=(scale_x*100);
                       oy:=(scale_y*100);
                       oz:=(scale_z*100);
                  end;}
     xini:=(xini+ox)*-1;
     yini:=(yini+oy)*-1;
     zini:=zini+oz;
     xfin:=(xfin+ox)*-1;
     yfin:=(yfin+oy)*-1;
     zfin:=zfin+oz;




     {1 cara}
      define_face(faces^[cara],  xfin,yfin,zini, xini,yfin,zini,
                                xini,yini,zini,  xfin,yini,zini);

     {2 cara}
      define_face(faces^[cara+1],  xini,yfin,zfin, xfin,yfin,zfin,
                          xfin,yini,zfin, xini,yini,zfin);


     {3 cara}
     define_face(faces^[cara+2],   xini,yfin,zini, xini,yfin,zfin,
                          xini,yini,zfin, xini,yini,zini);

     {4 cara}
     define_face(faces^[cara+3], xfin,yfin,zfin,  xfin,yfin,zini,
                           xfin,yini,zini,  xfin,yini,zfin);

     {5 cara}
     define_face(faces^[cara+4],   xini,yini,zfin, xfin,yini,zfin,
                          xfin,yini,zini, xini,yini,zini);

     {6 cara}
     define_face(faces^[cara+5],   xfin,yfin,zfin,  xini,yfin,zfin,
                           xini,yfin,zini,   xfin,yfin,zini);
     cara:=cara+6;

end; {end crear caras}

{writeln(xini:5,yini:5,zini:5);
writeln(xfin:5,yfin:5,zfin:5);}



writeln('Creating Vertex Table...');
{crear la tabla de vertices}
for x:=1 to p^.num_quads do
begin
   with faces^[x] do
   begin
       add_vertice(v^, x1,y1,z1);
       add_vertice(v^, x2,y2,z2);
       add_vertice(v^, x3,y3,z3);
       add_vertice(v^, x4,y4,z4);
   end;
end;

{************************************}

Writeln('Creating Poligons...');
{crear la tabla de Poligonos}
for x:=0 to p^.num_quads-1 do
begin
   with faces^[x+1] do
   begin
       p^.quad[x].p1:=seek_vertice(v^,x1,y1,z1);
       p^.quad[x].p2:=seek_vertice(v^,x2,y2,z2);
       p^.quad[x].p3:=seek_vertice(v^,x3,y3,z3);
       p^.quad[x].p4:=seek_vertice(v^,x4,y4,z4);

       if x<12 then p^.quad[x].texture:=$4001 else p^.quad[x].texture:=1;



   end;
end;

{**************************************************}
v^.num_vertices:=311;
p^.num_quads:=269;
t^.num_triangles:=22;
{*********** escribir el archivo ****************}
assign(f2,'fex.trl');
rewrite(f2);

writeln(f2,'; Room Meshes.txt version 1.5 **');
writeln(f2,'; Programado por Tpascal, Tegucigalpa, Honduras.');

writeln(f2,';');
writeln(f2,';');


writeln(f2,';Table of Vertices');
writeln(f2,';Format: Number of vertexs, then each vertex');
writeln(f2,';V[no]:=X Y Z ligth-intensity');
writeln(f2);


writeln(f2,':VERTEXS');
writeln(f2,v^.num_vertices:5);

for x:=1 to v^.num_vertices do
begin
   v^.vertice[x-1].light:=16;
   write(f2,'V[',x-1:4,']:=');
   write(f2,v^.vertice[x-1].x:9,' ');
   write(f2,v^.vertice[x-1].y:9,' ');
   write(f2,v^.vertice[x-1].z:9,' ');
   writeln(f2,v^.vertice[x-1].light:5,' ');
end;

writeln(f2);
writeln(f2);

writeln(f2,';QUADS (4 points figure)');
writeln(f2,';Format: Number of QUADS, then 4 vertex index and texture');
writeln(f2,';Q[no]:=v1 v2 v3 v4 texture-number');
writeln(f2);
writeln(f2,':QUADS');
writeln(f2,p^.num_quads:5);

for x:=1 to p^.num_quads do
begin
   write(f2,'Q[',x-1:4,']:=');
   write(f2,p^.quad[x-1].p1:5,' ');
   write(f2,p^.quad[x-1].p2:5,' ');
   write(f2,p^.quad[x-1].p3:5,' ');
   write(f2,p^.quad[x-1].p4:5,' ');
   writeln(f2,p^.quad[x-1].texture:5,' ');
end;
writeln(f2);
writeln(f2);


writeln(f2,';TRIANGLES (3 points figure)');
writeln(f2,';Format: Number of TRIANGLES, then 3 vertex index and texture');
writeln(f2,';T[no]:=v1 v2 v3 texture-number');
writeln(f2);


writeln(f2,':TRIANGLES');
writeln(f2,t^.num_triangles:5);
for x:=1 to t^.num_triangles do
begin
   write(f2,'T[',x-1:4,']:=');
   write(f2,t^.triangle[x-1].p1:5,' ');
   write(f2,t^.triangle[x-1].p2:5,' ');
   write(f2,t^.triangle[x-1].p3:5,' ');
   writeln(f2,t^.triangle[x-1].texture:5,' ');
end;



writeln(f2);
writeln(f2);
writeln(f2,';End of file.');


writeln('Done.');

close(f2);
{****************************************************}


end.




